---
category: [Administration & Integrations, Platform and Product Extensions, Platform and Product Extensions/Integration, Administration & Integrations/Custom Integrations & Apps, Platform and Product Extensions/Workday Extend]
keyword: Extend
nav: wcp_docs
parent_url: /wcp_docs/
title: Manage Requests
layout: subsection
---

### Context

<a id="context_N10027_N1001E_N10001"></a>
Workday enables you to configure requests as part of a Workday business process, making it easier for you to manage requests throughout your organization.

You can use the Request REST API to initiate, view, and close requests in Workday.

### Steps

1.  <a id="step_N10030_N1002D_N1001E_N10001"></a>Retrieve the specific request type you want to initiate.

    `GET https://api.workday.com/request/v1/types/<requestType_WID>`

    This call returns all of the information you need to initiate a request of this type, such as the questionnaire to be answered and the associated business object. You can then display this information on a custom interface.

    <b>Note:</b> To return all request types you can initiate, make the following request:

    `GET https://api.workday.com/request/v1/types`

    A typical response would contain the following information:

    -   A `descriptor` field, which contains the display ID of the Request Type instance.
    -   An `id` field, which contains the Workday ID of the Request Type instance.
    -   A `questionnaire` instance, which contains each question in the questionnaire associated with this Request Type. Each `question` instance contains the fields you need to properly display the question, such as the question type, whether or not the question is required, and the possible answers to the question.
    -   A `workdayObject` instance, which contains the business object associated with this Request Type instance.

    Sample GET Response:

    ```
    {
        "id": "530a8fffdf1a01aee7cb1bb213002384",
        "descriptor": "Request Change to a Business Process",
        "questionnaire": {
            "id": "530a8fffdf1a0111ee32fba813002084",
            "descriptor": "Request Change to BP",
            "referenceIdValue": "QUESTIONNAIRE-15-103",
            "questions": [
                {
                    "id": "530a8fffdf1a01c75df3fba813002184",
                    "descriptor": "Business Process to be changed for Request Change to BP",
                    "order": "a",
                    "type": {
                        "descriptor": "Text",
                        "id": "c4d9bd57996c100025ab7d7f5aed0046"
                    },
                    "body": "Which business process would you like to change?",
                    "required": false
                },
                {
                    "id": "530a8fffdf1a01333c50fca813002284",
                    "descriptor": "Date of change for Request Change to BP",
                    "required": true,
                    "order": "b",
                    "body": "When would you like this change to take effect?",
                    "type": {
                        "descriptor": "Date",
                        "id": "85fb160ed47910001589e3a427670070"
                    }
                }
            ],
            "questionnaireInstructions": "Please fill out the questions below. The more detail you provide, the quicker we can resolve your request.",
            "name": "Request Change to BP"
        },
        "workdayObject": {
            "descriptor": "Business Process Definition",
            "id": "ba7f3fd6652b100008192a14830c3125"
        },
        "description": "Submit this request to your Workday administrator to change an existing business process in the Workday system."
    }
     
    ```

2.  <a id="step_N1006C_N1002C_N1001E_N10001"></a>Use the information you retrieved from this response to initiate the request.

    `POST https://api.workday.com/request/v1/requests`

    Sample POST Request Body:

    ```
    {
        "comment": "Please review this ASAP",
        "description": "Please add another Approval step to route to the Manager's Manager, after the first approval.",
        "requestType":{
            "id": "530a8fffdf1a01aee7cb1bb213002384"
        },
        "questionnaireResponses": {
            "questionnaireAnswers": [
                {
                    "questionItem": {
                        "id": "530a8fffdf1a01c75df3fba813002184"
                    },
                     "answerText": "Title Change BP for Global Modern Services 1000"
                },
                {
                    "questionItem": {
                        "id": "530a8fffdf1a01333c50fca813002284"
                    },
                     "answerDate": "2019-09-16"
                }
                
            ]
        }
    }
     
    ```

    This call returns information about the completed request, such as the Workday ID of the submitted request and the completed questionnaire response.

    Sample POST Response:

    ```
    {
        "id": "530a8fffdf1a81decfcb160c15002b84",
        "descriptor": "Request : Request Change to a Business Process : Super User",
        "description": "Please add another Approval step to route to the Manager's Manager, after the first approval.",
        "requestDate": "2019-08-28T00:11:29.410Z",
        "initiator": {
            "descriptor": "Super User",
            "id": "1b85d51c985e4953951dc4d16b5c0de6"
        },
        "questionnaireResponses": {
            "id": "530a8fffdf1a81bfe117190c15002d84",
            "descriptor": "Response for Request Change to BP",
            "creationDate": "2019-08-27",
            "questionnaireResponseStatus": {
                "descriptor": "Completed",
                "id": "73e8975b2ace100012503d7f9ae1003b"
            },
            "questionnaireAnswers": [
                {
                    "id": "530a8fffdf1a812bfca8190c15002f84",
                    "descriptor": "Title Change BP for Global Modern Services 1000",
                    "answerText": "Title Change BP for Global Modern Services 1000",
                    "branching": false,
                    "questionBody": "Which business process would you like to change?",
                    "questionItem": {
                        "descriptor": "Business Process to be changed for Request Change to BP",
                        "id": "530a8fffdf1a01c75df3fba813002184"
                    },
                    "questionOrder": "a"
                },
                {
                    "id": "530a8fffdf1a8139cb5f190c15002e84",
                    "descriptor": "09/16/2019",
                    "questionItem": {
                        "descriptor": "Date of change for Request Change to BP",
                        "id": "530a8fffdf1a01333c50fca813002284"
                    },
                    "questionOrder": "b",
                    "questionBody": "When would you like this change to take effect?",
                    "branching": false,
                    "answerDate": "2019-09-16"
                }
            ]
        },
        "status": {
            "descriptor": "In Progress",
            "id": "e2d08afc53614c37b32b31270bb8bee3"
        },
        "requestType": {
            "descriptor": "Request Change to a Business Process",
            "id": "530a8fffdf1a01aee7cb1bb213002384"
        },
        "requestEvent": {
            "descriptor": "Request Process : Request Change to a Business Process : Super User",
            "id": "530a8fffdf1a01ca7862170c15002c84"
        }
    }
     
    ```

3.  <a id="step_N1007E_N1002C_N1001E_N10001"></a>(Optional) Close the submitted request.
    1.  Retrieve the submitted request to display its details.

        `GET https://api.workday.com/request/v1/requests/<request_WID>`

        Sample GET Response:

        ```
        {
            "id": "530a8fffdf1a81decfcb160c15002b84",
            "descriptor": "Request : Request Change to a Business Process : Super User",
            "description": "Please add another Approval step to route to the Manager's Manager, after the first approval.",
            "requestDate": "2019-08-28T00:11:29.410Z",
            "initiator": {
                "descriptor": "Super User",
                "id": "1b85d51c985e4953951dc4d16b5c0de6"
            },
            "questionnaireResponses": {
                "id": "530a8fffdf1a81bfe117190c15002d84",
                "descriptor": "Response for Request Change to BP",
                "creationDate": "2019-08-27",
                "questionnaireResponseStatus": {
                    "descriptor": "Completed",
                    "id": "73e8975b2ace100012503d7f9ae1003b"
                },
                "questionnaireAnswers": [
                    {
                        "id": "530a8fffdf1a812bfca8190c15002f84",
                        "descriptor": "Title Change BP for Global Modern Services 1000",
                        "answerText": "Title Change BP for Global Modern Services 1000",
                        "branching": false,
                        "questionBody": "Which business process would you like to change?",
                        "questionItem": {
                            "descriptor": "Business Process to be changed for Request Change to BP",
                            "id": "530a8fffdf1a01c75df3fba813002184"
                        },
                        "questionOrder": "a"
                    },
                    {
                        "id": "530a8fffdf1a8139cb5f190c15002e84",
                        "descriptor": "09/16/2019",
                        "questionItem": {
                            "descriptor": "Date of change for Request Change to BP",
                            "id": "530a8fffdf1a01333c50fca813002284"
                        },
                        "questionOrder": "b",
                        "questionBody": "When would you like this change to take effect?",
                        "branching": false,
                        "answerDate": "2019-09-16"
                    }
                ]
            },
            "status": {
                "descriptor": "In Progress",
                "id": "e2d08afc53614c37b32b31270bb8bee3"
            },
            "requestType": {
                "descriptor": "Request Change to a Business Process",
                "id": "530a8fffdf1a01aee7cb1bb213002384"
            },
            "requestEvent": {
                "descriptor": "Request Process : Request Change to a Business Process : Super User",
                "id": "530a8fffdf1a01ca7862170c15002c84"
            }
        }
         
        ```

    2.  Review the request details, and then close the request.

        `POST https://api.workday.com/request/v1/requests/<request_WID>/close`

        Sample POST Request Body:

        ```
        {
            "comment": "Closing request as a duplicate - Ashwin Kumar",
            "resolution": {
                "id": "be256002ae2010000bfd6ae5ea5b0148"
            },
            
            "workdayObjectValue": {
                "id": "1b01f84ec15d4a609529157a1b5b0cff"
            }
        }
         
        ```

        Sample POST Response:

        ```
        {
            "id": "530a8fffdf1a81decfcb160c15002b84",
            "descriptor": "Request : Request Change to a Business Process : Super User",
            "comment": "Closing request as a duplicate - Ashwin Kumar",
            "workdayObjectValue": {
                "descriptor": "Title Change for 1000 Global Modern Services",
                "id": "1b01f84ec15d4a609529157a1b5b0cff"
            },
            "resolution": {
                "descriptor": "Canceled",
                "id": "be256002ae2010000bfd6ae5ea5b0148"
            }
        }
         
        ```




### Result

<a id="result_N10038_N1001E_N10001"></a>
The request is now closed and the <i>Request</i> business process associated with it is complete.

If there are more steps in the associated <i>Request</i> business process, the business process continues to the next step.

### Next Steps

<a id="postreq_typ_dtl_qmb"></a>
You can use the Business Process REST API to:

-   Retrieve the In Progress steps, Completed steps, or Remaining steps for the Request event.
-   Approve, deny, or send back a step in the <i>Request</i> business process.


You can also use the Business Process REST API to retrieve the attachments on the Request event.

### Related Information

[Reference: Workday Extend API Gateways and Authorization Base URLs](/wcp_docs/dlh1653340161856.html)

